#define __OCICPP_INTERNAL_USE_

#include "OraDate.h"

OraDate::OraDate(OCIEnv *envhp,OCIError *errhp,OCIParam *param,ub2 type) : OraType(envhp,errhp,param,type) {
	ReqType=SQLT_DAT;
	size=10; /* DD-MM-YYYY */
}

OraDate::~OraDate() {
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);
}

void OraDate::define(OCIStmt *stmt,int col) {
	CHECKERR(err, OCIDefineByPos(stmt, &definehp, err, col+1, date, 7,ReqType,
	 								(dvoid *) &null, 0, (ub2 *)0, OCI_DEFAULT)); 	
}

void OraDate::getStr(string &str) {
	char buf[12];
	char *month[]={"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
	unsigned char cc,yy,mm,dd,hh,mi,ss;
	cc=date[0]; /* Century */
	yy=date[1]; /* Year */
	mm=date[2]; /* Month */
	dd=date[3]; /* Day */
	hh=date[4]; /* Hour */
	mi=date[5]; /* Minute */
	ss=date[6]; /* Seconds */
	cc=(unsigned char)abs(cc-100);
	yy=(unsigned char)abs(yy-100);
	sprintf(buf,"%d-%s-%d",dd,month[mm-1],(unsigned int)cc*100+(unsigned int)yy);
	str.assign(buf);
}

void OraDate::getStrMon(string &mon) {
	char *month[]={"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
	unsigned char mm=date[2]; /* Month */
	mon.assign(month[mm]);
}

void OraDate::getSec(int &sec) {
	sec=(int) date[6];
}


void OraDate::getMin(int &min) {
	min=(int) date[5];
}
void OraDate::getHour(int &hour) {
	hour=(int) date[4];
}
void OraDate::getDay(int &day) {
	day=(int) date[3];
}
void OraDate::getMonth(int &mon) {
	mon=(int) date[2];
}
void OraDate::getYear(int &year) {
	unsigned char yy,cc;
	yy=date[1];
	cc=date[0];
	yy=(unsigned char)abs(yy-100);
	cc=(unsigned char)abs(cc-100);
	year=(int)cc*100+(int)yy;
}



